%global mplversion 2.12.1
%bcond_with qt4

Summary:        A comprehensive library for creating static, animated, and interactive visualizations
Name:           python-matplotlib
Version:        3.6.3
Release:        2%{?dist}
License:        Python and MIT and OFL-1.1 and Public Domain
URL:            https://github.com/matplotlib/matplotlib
Source0:        https://github.com/matplotlib/matplotlib/archive/v%{version}/matplotlib-%{version}.tar.gz
Source1:        setup.cfg
Source2:        https://github.com/QuLogic/mpl-images/archive/v%{version}-with-freetype-%{mplversion}/matplotlib-3.6.1-with-freetype-%{mplversion}.tar.gz

Patch0001:      0001-matplotlibrc-path-search-fix.patch
Patch0002:      0002-Set-FreeType-version-to-%{mplversion}-and-update-tolerances.patch
Patch0003:      0003-Increase-a-few-test-tolerances-on-some-arches.patch

BuildRequires: xorg-x11-server-Xvfb zlib-devel python3-certifi gcc gcc-c++
BuildRequires: freetype-devel libpng-devel qhull-devel python-setuptools_scm


%description
The package produces publication-quality figures in a variety of hardcopy formats and interactive environments
across platforms.

%package -n     python-matplotlib-data
Summary:        Data used by python-matplotlib
BuildArch:      noarch
Requires:       python-matplotlib-data-fonts = %{version}-%{release}

%description -n python-matplotlib-data
Data used by python-matplotlib.

%package -n     python-matplotlib-data-fonts
Summary:        Fonts used by python-matplotlib
BuildArch:      noarch
Requires:       python-matplotlib-data = %{version}-%{release}

%description -n python-matplotlib-data-fonts
Fonts used by python-matplotlib.

%package -n     python3-matplotlib
Summary:        Plotting with Python
BuildRequires:  python3-cairo python3-cycler >= 0.10.0 python3-dateutil python3-devel
BuildRequires:  python3-setuptools python3-gobject python3-kiwisolver python3-numpy
BuildRequires:  python3-pillow python3-pyparsing python3-pytz python3-six python3-sphinx
Requires:       dejavu-sans-fonts python-matplotlib-data = %{version}-%{release}
Requires:       python3-cairo python3-cycler >= 0.10.0 python3-dateutil python3-kiwisolver
Requires:       python3-matplotlib-tk = %{version}-%{release} python3-numpy
Requires:       python3-pyparsing python3-pytz python3-six
Provides:       bundled(stix-math-fonts)
Recommends:     python3-pillow

%description -n python3-matplotlib
The package produces publication-quality figures in a variety of hardcopy formats and interactive environments
across platforms.

%if %{with qt4}
%package -n     python3-matplotlib-qt4
Summary:        Qt4 backend for python3-matplotlib
BuildRequires:  python3-PyQt4-devel
Requires:       python3-matplotlib = %{version}-%{release} python3-matplotlib-qt5 python3-PyQt4

%description -n python3-matplotlib-qt4
The qt4 backend for python3-matplotlib.
%endif

%package -n     python3-matplotlib-qt5
Summary:        Qt5 backend for python3-matplotlib
BuildRequires:  python3-qt5
Requires:       python3-matplotlib = %{version}-%{release} python3-qt5

%description -n python3-matplotlib-qt5
The qt5 backend for python3-matplotlib.

%package -n     python3-matplotlib-gtk3
Summary:        GTK3 backend for python3-matplotlib
BuildRequires:  gtk3 python3-gobject
Requires:       gtk3 python3-gobject python3-matplotlib = %{version}-%{release}

%description -n python3-matplotlib-gtk3
The gtk3 backend for python3-matplotlib.

%package -n     python3-matplotlib-tk
Summary:        Tk backend for python3-matplotlib
BuildRequires:  python3-tkinter
Requires:       python3-matplotlib = %{version}-%{release} python3-tkinter

%description -n python3-matplotlib-tk
The tk backend for python3-matplotlib.

%package -n     python3-matplotlib-test-data
Summary:        Test data for python3-matplotlib
Requires:       python3-matplotlib = %{version}-%{release}

%description -n python3-matplotlib-test-data
Test data for python3-matplotlib.

%prep
%autosetup -n matplotlib-%{version} -p1
gzip -dc %SOURCE2 | tar xf - --transform='s~^mpl-images-3.6.1-with-freetype-%{mplversion}/~~'

cp -p %{SOURCE1} mplsetup.cfg

	
%build
export http_proxy=http://127.0.0.1/
find examples -name '*.py' -exec chmod a-x '{}' \;

PLCONFIGDIR=$PWD %py3_build

%install
export http_proxy=http://127.0.0.1/

MPLCONFIGDIR=$PWD %py3_install

mkdir -p %{buildroot}%{_sysconfdir} %{buildroot}%{_datadir}/matplotlib
mv %{buildroot}%{python3_sitearch}/matplotlib/mpl-data %{buildroot}%{_datadir}/matplotlib

%files -n python-matplotlib-data
%{_datadir}/matplotlib/mpl-data/
%exclude %{_datadir}/matplotlib/mpl-data/fonts/

%files -n python-matplotlib-data-fonts
%{_datadir}/matplotlib/mpl-data/fonts/


%files -n python3-matplotlib
%license LICENSE/
%doc README.rst
%{python3_sitearch}/{*egg-info,matplotlib-*-nspkg.pth,matplotlib/}
%{python3_sitearch}/mpl_toolkits/
%{python3_sitearch}/{pylab.py*,__pycache__/*}
%exclude %{python3_sitearch}/matplotlib/tests/baseline_images/*
%exclude %{python3_sitearch}/mpl_toolkits/tests/baseline_images/*
%if %{with qt4}
%exclude %{python3_sitearch}/matplotlib/backends/{backend_qt4*,__pycache__/backend_qt4*}
%endif
%exclude %{python3_sitearch}/matplotlib/backends/{backend_qt5*,__pycache__/backend_qt5*}
%exclude %{python3_sitearch}/matplotlib/backends/{backend_gtk*,__pycache__/backend_gtk*}
%exclude %{python3_sitearch}/matplotlib/backends/{backend_tkagg.*,__pycache__/backend_tkagg.*}
%exclude %{python3_sitearch}/matplotlib/backends/{tkagg.*,__pycache__/tkagg.*,_tkagg.*}

%files -n python3-matplotlib-test-data
%{python3_sitearch}/matplotlib/tests/baseline_images/
%{python3_sitearch}/mpl_toolkits/tests/baseline_images/

%if %{with qt4}
%files -n python3-matplotlib-qt4
%{python3_sitearch}/matplotlib/backends/{backend_qt4.*,__pycache__/backend_qt4.*}
%{python3_sitearch}/matplotlib/backends/{backend_qt4agg.*,__pycache__/backend_qt4agg.*}
%endif

%files -n python3-matplotlib-qt5
%{python3_sitearch}/matplotlib/backends/{backend_qt5.*,__pycache__/backend_qt5.*}
%{python3_sitearch}/matplotlib/backends/{backend_qt5agg.*,__pycache__/backend_qt5agg.*}

%files -n python3-matplotlib-gtk3
%{python3_sitearch}/matplotlib/backends/{backend_gtk*,__pycache__/backend_gtk*}

%files -n python3-matplotlib-tk
%{python3_sitearch}/matplotlib/backends/{backend_tkagg.py*,__pycache__/backend_tkagg.*}
%{python3_sitearch}/matplotlib/backends/{tkagg.*,__pycache__/tkagg.*,_tkagg.*}

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.6.3-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 21 2023 cunshunxia <cunshunxia@tencent.com> - 3.4.3-1
- initial build
